function y = KTKx_lin(x,P,varargin)

if nargin < 3 || isempty(varargin{1})
    padding = 0; else padding = varargin{1}; end
if nargin < 4 || isempty(varargin{2})
    interp_type = 'triang'; else interp_type = varargin{2}; end

if iscell(P)
    y = KTx_lin( Kx_lin(x,P,padding,interp_type) ,P,padding,interp_type );
else % single psf
    [N M] = size(x);
    [rax rlat] = size(P);
    rax = rax-1; rlat = rlat-1;
    xpad = padarray(x,[rax/2 rlat/2],padding);
    [nP mP] = size(xpad);
    psf = padarray( P , [nP-rax-1 mP-rlat-1], 'post' );
    psf = circshift( psf , [-floor(rax/2) -floor(rlat/2) ] );
    H = abs(fft2( psf )).^2;
    y = ifft2(H.*fft2(xpad));
    y = y( rax/2+1:rax/2+N,rlat/2+1:rlat/2+M );
end