function y = Kx_lin(x,P,varargin)

if nargin < 3 || isempty(varargin{1})
    padding = 'circular'; 
else
    padding = varargin{1};
end

% -- product Kx for spatially variant blurs using linear interpolation
% suppose variations just in axial direction
[N M] = size(x);
 % single psf 
[rax rlat] = size(P);
rax = rax-1; rlat = rlat-1;
xpad = padarray(x,[rax/2 rlat/2],padding);
[nP mP] = size(xpad);
psf = padarray( P , [nP-rax-1 mP-rlat-1], 'post' );
psf = circshift( psf , [-floor(rax/2) -floor(rlat/2) ] );
H = (fft2( psf ));
y = ifft2(H.*fft2(xpad));
y = y( rax/2+1:rax/2+N,rlat/2+1:rlat/2+M );
if isreal(x)
    y = real(y);
end
