function [ beta_new,walk_beta,wind,accept] = granularity_sample_MH( beta_old,B,z,u,walk_beta,wind,ii,n0)
[m,n]=size(z);
% generate beta candidate 
beta_cand=beta_old+walk_beta*randn;
% generate auxiliary vector w
w=generate_w(m,n,z,beta_cand);

if beta_cand>0 && beta_cand<B
    if abs(eta(z)-eta(w))<u*eta(z)
        beta_new=beta_cand;
        label=1;
    else
        beta_new=beta_old;
        label=0;
    end
else
    beta_new=beta_old;
    label=0;
end

% adjust the random walk size 
nwind=30;
wind=[wind(1,2:nwind),label];
accept=mean(wind);
if ii-1<=n0
    if  accept<0.4
        walk_beta=walk_beta*(1-0.2);
    elseif accept>0.8
        walk_beta= walk_beta*(1+0.2);
    end
% elseif ii-1>n0
%     if  accept<0.35
%         walk_xi=walk_xi*(1-0.1*exp(-0.01*(ii-n0)));
%         elseif accept_xi>0.85
%         walk_xi= walk_xi*(1+0.1*exp(-0.01*(ii-n0)));
%     end
end
end



function w=generate_w(m,n,z,beta)
t=zeros(m+2,n+2);
t(2:end-1,2:end-1)=z;
tt=zeros(m+2,n+2);
for i=2:m+1
    for j=2:n+1
        temp=[t(i-1,j), t(i,j-1), t(i+1,j), t(i,j+1)];
        ind=find(temp==t(i,j));
        tt(i,j)=numel(ind);
%         tt(i,j)=exp(beta*tt(i,j));
    end
end
w=tt(2:m+1,2:n+1);
end
    
function eta=eta(x)
[m,n]=size(x);
t=zeros(m+2,n+2);
t(2:end-1,2:end-1)=x;
tt=zeros(m+2,n+2);
for i=2:m+1
    for j=2:n+1
        temp=[t(i-1,j), t(i,j-1), t(i+1,j), t(i,j+1)];
        ind=find(temp==t(i,j));
        tt(i,j)=numel(ind);
    end
end
eta=tt(2:m+1,2:n+1);
eta=sum(eta(:));
end