function[z_new,ind] = label_sample_MRF_8neighbours( z_old,x,K,beta,xi,scale,mu,ch)
%this code is to use Potts Markov fields as the prior of the labels
%the number of neighbour element is 8
% using checkeboard, 4 times are needed to sampled all the labels

[m,n]=size(z_old);
[b{1},b{2},b{3},b{4}]=checkerboard(m,n);
sum_pi=zeros(m,n);
pi=zeros(m,n,K);
board=zeros(m,n,K);
posterior_pi=cell(1,K);
bound=cell(1,K+1);

if ch==1
    ind=find(b{1}==1);
elseif ch==2
    ind=find(b{2}==1);
elseif ch==3
    ind=find(b{3}==1);
elseif ch==4
    ind=find(b{4}==1);
end

for k=1:K
    board(:,:,k)=neighbours(z_old,k,ch);
    pi(:,:,k)=exp(beta*board(:,:,k)).*exp(-abs(x-mu(k)).^xi(k)/scale(k))/(2*scale(k)^(1/xi(k))*gamma(1+1/xi(k)));%GGD (likelihood) case
    sum_pi=sum_pi+pi(:,:,k);
end

for k=1:K
    posterior_pi{k}=pi(:,:,k)./sum_pi.*b{ch};
end

temp=z_old(ind);
rho=rand(numel(temp),1);
% rho=rand;
bound{1}=zeros(size(temp));
temp=(bound{1}<=rho);
for i=2:K+1
    bound{i}=posterior_pi{i-1}(ind);
    bound{i}=bound{i}+bound{i-1};
    temp=temp+(bound{i}<=rho);
end
z_new=temp;
end


function [b1,b2,b3,b4]=checkerboard(m,n)
b1=zeros(m,n);
b2=zeros(m,n);
b3=zeros(m,n);
b4=zeros(m,n);
%b1
for i=1:2:m
    for j=1:2:n
     b1(i,j)=1;
    end
end
%b2
for i=1:2:m
    for j=2:2:n
      b2(i,j)=1;
    end
end
%b3
for i=2:2:m
    for j=1:2:n
      b3(i,j)=1;
    end
end
%b4
for i=2:2:m
    for j=2:2:n
        b4(i,j)=1;
    end
end
end

function [bboard]=neighbours(z,k,ch)
[m,n]=size(z);
t=zeros(m+2,n+2);
t(2:end-1,2:end-1)=z;
tb=zeros(size(t));

if ch==1
%board1
    for i=2:2:m+1
        for j=2:2:n+1
            temp1=[t(i-1,j), t(i,j-1),t(i,j+1), t(i+1,j) ];
            temp2=[t(i-1,j-1),t(i-1,j+1),t(i+1,j-1),t(i+1,j+1)];
            ind1=find(temp1==k);
            ind2=find(temp2==k);
            tb(i,j)=numel(ind1)+.5*numel(ind2);
        end
    end
bboard=tb(2:end-1,2:end-1);

elseif ch==2
    for i=2:2:m+1
        for j=3:2:n+1
            temp1=[t(i-1,j), t(i,j-1),t(i,j+1), t(i+1,j) ];
            temp2=[t(i-1,j-1),t(i-1,j+1),t(i+1,j-1),t(i+1,j+1)];
            ind1=find(temp1==k);
            ind2=find(temp2==k);
            tb(i,j)=numel(ind1)+.5*numel(ind2);
        end
    end
    bboard=tb(2:end-1,2:end-1);
elseif ch==3
    for i=3:2:m+1
        for j=2:2:n+1
            temp1=[t(i-1,j), t(i,j-1),t(i,j+1), t(i+1,j) ];
            temp2=[t(i-1,j-1),t(i-1,j+1),t(i+1,j-1),t(i+1,j+1)];
            ind1=find(temp1==k);
            ind2=find(temp2==k);
            tb(i,j)=numel(ind1)+.5*numel(ind2);
        end
    end
    bboard=tb(2:end-1,2:end-1);    
elseif ch==4
    for i=3:2:m+1
        for j=3:2:n+1
            temp1=[t(i-1,j), t(i,j-1),t(i,j+1), t(i+1,j) ];
            temp2=[t(i-1,j-1),t(i-1,j+1),t(i+1,j-1),t(i+1,j+1)];
            ind1=find(temp1==k);
            ind2=find(temp2==k);
            tb(i,j)=numel(ind1)+.5*numel(ind2);
        end
    end
    bboard=tb(2:end-1,2:end-1);    
end

end
