function [ h_new,epsilon,fenetre,accept_r ] = sample_PSF_HMC( h_current,epsilon,L,ii,n0,fenetre,h0,x,y,sig2n,sig2h )

% written by N.ZHAO (ENSEEIHT-IRIT, PhD student)
% date: 2014/09/09

% initialization
h_cand=h_current; 
m=1;
p=m*randn(size(h_cand)); %the introduced momentum variables
current_p=p;
%% leapfrog method
% make a half step for momentum at the beginning
p=p-epsilon/2*grad_U(h_cand,y,sig2n,sig2h);
% alternate full steps for position and momentum
p=-p;
for i=1:L
    %make a full step for the position
    h_cand=h_cand+epsilon*p/m;
    %make a full strp for the momentum, except at end of trajectory
    if (i~=L) 
       p=p-epsilon*grad_U(h_cand,y,sig2n,sig2h);
    end
end
%make a half step for momentum at the end
p=p-epsilon/2*grad_U(h_cand,y,sig2n,sig2h);
% negate momentum at end of trajectory to make the proposal symmetric?
p=-p;





end

function grad = grad_U(h,y,x,sig2n,sig2h,h0)

grad1=KTx_lin(conv2(x,h,'same')-y,x)/sig2n;
grad2=(h-h0)/sig2h;

end