function [X,rho,zeta,accept_r,Window] = sample_X_hamiltonian(X,Y,Z,psfY,psfZ,sigma2y,sigma2z,nbleapfrog,zeta,Window,s2_inv,miu_x,Mark,prior,Num_G,P_vec,Nbi,i)
p_cov=1; 
p = sqrt(p_cov)*randn(size(X));
X_cand = X;
p_cand=p;
gradU = func_grad(X_cand,Y,Z,psfY,psfZ,sigma2y,sigma2z,s2_inv,miu_x,prior,Mark,Num_G,P_vec);

for leapfrog = 1:nbleapfrog 
    p_cand = p_cand - 1/2*zeta*gradU;
    X_cand = X_cand + zeta*p_cand/p_cov;
    if strcmp(prior,'Uniform')
        p_cand(X_cand<0 | X_cand>1)=(-1)*p_cand(X_cand<0|X_cand>1);
        X_cand(X_cand<0)=(-1)*X_cand(X_cand<0);
        X_cand(X_cand>1)=2-X_cand(X_cand>1);
    end    
    gradU = func_grad(X_cand,Y,Z,psfY,psfZ,sigma2y,sigma2z,s2_inv,miu_x,prior,Mark,Num_G,P_vec);
    p_cand = p_cand - 1/2*zeta*gradU;       
end

err_courY = Y-func_blurringY(var_dim(X,P_vec,'inc'),psfY);
err_candY = Y-func_blurringY(var_dim(X_cand,P_vec,'inc'),psfY);
err_courZ = Z-func_blurringZ(var_dim(X,P_vec,'inc'),psfZ);
err_candZ = Z-func_blurringZ(var_dim(X_cand,P_vec,'inc'),psfZ);

if strcmp(prior,'MRF') || strcmp(prior,'GMM')
    [~,obj_cour]= func_grad(X,Y,Z,psfY,psfZ,sigma2y,sigma2z,s2_inv,miu_x,prior,Mark,Num_G,P_vec);
    [~,obj_cand]= func_grad(X_cand,Y,Z,psfY,psfZ,sigma2y,sigma2z,s2_inv,miu_x,prior,Mark,Num_G,P_vec);
elseif strcmp(prior,'Uniform')
    obj_cour = 0;    obj_cand = 0; 
elseif strcmp(prior,'Dic')
    [~,obj_cour]= func_grad(X,Y,Z,psfY,psfZ,sigma2y,sigma2z,s2_inv,miu_x,prior,Mark,Num_G,P_vec);
    [~,obj_cand]= func_grad(X_cand,Y,Z,psfY,psfZ,sigma2y,sigma2z,s2_inv,miu_x,prior,Mark,Num_G,P_vec);
end
obj_cour = obj_cour + 1/(2*sigma2y) * norm(err_courY(:))^2 + 1/(2*sigma2z) * norm(err_courZ(:))^2 + 1/(2*p_cov)*norm(p(:))^2;
obj_cand = obj_cand + 1/(2*sigma2y) * norm(err_candY(:))^2 + 1/(2*sigma2z) * norm(err_candZ(:))^2 + 1/(2*p_cov)*norm(p_cand(:))^2; 

rho = min([1 exp(obj_cour-obj_cand)]);
if rand<rho
    X = X_cand;  ac_Mark=1;
else
    ac_Mark=0;
end
[~,Col]=size(Window);Window=[Window(:,2:Col) ac_Mark];accept_r=sum(Window,2)/Col;
%Adjust the stepsize adaptively with the acceptance ratio
epsilon_u=0.25;epsilon_d=0.35;
if i<=Nbi
    if  accept_r<0.65-epsilon_d
        zeta=zeta*(1-0.1);
    elseif accept_r>0.65+epsilon_u
        zeta= zeta*(1+0.1);
    end
elseif i>Nbi
    if  accept_r<0.65-epsilon_d
        zeta=zeta*(1-0.1*exp(-0.01*(i-Nbi)));
    elseif accept_r>0.65+epsilon_u
        zeta= zeta*(1+0.1*exp(-0.01*(i-Nbi)));
    end    
end