function [ alpha_new,accept,wind,walk_alpha ] = sample_alpha_MH( alpha_old,beta,x,z,k,walk_alpha,wind,ii,n0 )
% 2014/06/24
% by N.ZHAO
% sampling the shape parameter alpha of Gamma distribution
% prior is uniform distribution

theta=x(z==k);
N=numel(theta);
alpha_cand=alpha_old+walk_alpha*randn;

% likelihood function (negetive log of the posterior distribution)
p_func=@(alpha) N*log(gamma(alpha)*beta^alpha)-sum((k-1)*log(theta))+sum(theta)/beta;
p_cand=p_func(alpha_cand);
p_old=p_func(alpha_old);

if alpha_cand<=3 && alpha_cand>=0.01 
    accept= min(exp(p_old-p_cand),1);
else
    accept=0;
end
    
urn = rand;
if urn<=accept
    alpha_new=alpha_cand;
    label=1;
else
    alpha_new=alpha_old;
    label=0;
end

% adjust the random walk size 
nwind=30;
wind=[wind(1,2:nwind),label];
accept=mean(wind);
if ii-1<=n0
    if  accept<0.4
        walk_alpha=walk_alpha*(1-0.2);
    elseif accept>0.8
        walk_alpha= walk_alpha*(1+0.2);
    end
elseif ii-1>n0
    if  accept<0.4
        walk_alpha=walk_alpha*(1-0.1*exp(-0.01*(ii-n0)));
    elseif accept>0.8
        walk_alpha= walk_alpha*(1+0.1*exp(-0.01*(ii-n0)));
    end
end
end





