function [sig2x,accept_sig2x,wind,walk_sig2x]= sample_sig2x_MH(sig2x_old,xi,x,walk_sig2x,wind,ii,n0)
%|sample sig2x using Metropolis Hastings method with random walk
%|prior of sig2x: uniform distribution
N=numel(x);
sig2x_cand = sig2x_old + walk_sig2x*randn;     
b_cand=sqrt(sig2x_cand*gamma(1/xi)/gamma(3/xi));
b_old=sqrt(sig2x_old*gamma(1/xi)/gamma(3/xi));

f_func=@(b,sig2x) N*log(2*b*gamma(1+1/xi))+norm(x(:),xi)^xi/b^xi+log(sig2x);
f_cand=f_func(b_cand,sig2x_cand);
f_old=f_func(b_old,sig2x_old);

if sig2x_cand>0.1
    %support of the target distribution, and the lower bound should be larger than 0 
    accept= min(exp(f_old-f_cand),1);
else
    accept=0;
end
   
urn = rand(1);
if urn<=accept
    sig2x=sig2x_cand;
    label=1;
else
    sig2x=sig2x_old;
    label=0;
end
%% adjust the random walk size 
nwind=30;
wind=[wind(1,2:nwind),label];
accept_sig2x=mean(wind);
if ii-1<=n0
    if  accept_sig2x<0.3
        walk_sig2x=walk_sig2x*(1-0.1);
    elseif accept_sig2x>0.9
        walk_sig2x= walk_sig2x*(1+0.1);
    end
elseif ii-1>n0
    if  accept_sig2x<0.3
        walk_sig2x=walk_sig2x*(1-0.1*exp(-0.01*(ii-n0)));
        elseif accept_sig2x>0.9
        walk_sig2x= walk_sig2x*(1+0.1*exp(-0.01*(ii-n0)));
    end
end
    

