function [xi,accept_xi,wind,walk_xi] = sample_xi_MH(xi_old,sig2x,x,walk_xi,wind,ii,n0)
%|sample \xi using Metropolis Hastings method with random walk
%|prior of xi: uniform distribution
N=numel(x);
xi_cand = xi_old+walk_xi*randn;

% % negative log of the posterior distribution w.r.t. xi, and the
% likelihood function wrt xi is ggd
%%% the posterior distribution w.r.t. xi isn't used directly because it will cause NaN in the
%%% denomenator
p_func=@(xi,b) N*log(2*b*gamma(1+1/xi))+norm(x(:),xi)^xi/(b^xi);
b_cand=sqrt(sig2x*gamma(1/xi_cand)/gamma(3/xi_cand));
b_old=sqrt(sig2x*gamma(1/xi_old)/gamma(3/xi_old));
p_cand=p_func(xi_cand,b_cand);
p_old=p_func(xi_old,b_old);


if xi_cand<=3.01 && xi_cand>=0.01 
%    support of the target distribution, and the lower bound should be larger than 0 
    accept= min(exp(p_old-p_cand),1);
else accept=0;
end
    
urn = rand;
if urn<=accept
    xi=xi_cand;
    label=1;
else
    xi=xi_old;
    label=0;
end
% adjust the random walk size 
nwind=30;
wind=[wind(1,2:nwind),label];
accept_xi=mean(wind);
if ii-1<=n0
    if  accept_xi<0.3
        walk_xi=walk_xi*(1-0.2);
    elseif accept_xi>0.9
        walk_xi= walk_xi*(1+0.2);
    end
elseif ii-1>n0
    if  accept_xi<0.3
        walk_xi=walk_xi*(1-0.1*exp(-0.01*(ii-n0)));
        elseif accept_xi>0.9
        walk_xi= walk_xi*(1+0.1*exp(-0.01*(ii-n0)));
    end
end




