function sig2n = sig2n_sample_Gibbs(theta,psf,y,varargin)
%|this program is to sample the variance of noise according to its
%|conditional posterior distribution
%|p(sig2n|...) \sim IG(alpha+N/2,beta2+.5*||y-HPx||^2)
%|2014/02/21
if nargin < 3
    error('Not enough inputs');
end

if nargin<4
    alpha=0; 
    beta=0;
elseif nargin<5
    alpha=0; 
    beta=varargin{1};
else
    alpha=varargin{1};
    beta=varargin{2};
end

global N N_lev Fsf sf;

x_temp=idualtree2D(theta, N_lev, Fsf, sf);
temp=y-conv2(x_temp,psf,'same');
sig2n=1/gamrnd(alpha+N/2,1/(beta+.5*norm(temp(:))^2));
end