%case 'GGDrnd' and 'simu': refx==1
%case 'real':refx==0
if refx==1
    %% ground truth known
    figure(1),
    subplot(221),imagesc(refl),colormap gray
    title('True reflectivity function')
    subplot(222),imagesc(y),colormap gray
    title('RF image')
    subplot(223),imagesc(x0),colormap gray
    title('Initial guess')
    subplot(224),imagesc(x_hat),colormap gray
    title('Estimated reflectivity function')
    
    figure(2),
    imagesc(z_map);colorbar
    title('Estimated label map')
    
    figure(3),plot(sig2n_est.sample),title('sig2n')
    hold on, plot(sig2n_est.mmse*ones(length(sig2n_est.sample),1),'r.'), hold off;
    hold on, plot(sig2n_ref*ones(length(sig2n_est.sample),1),'g.'), hold off
    legend('samples','MMSE','truth');
    title('noise variance')
    %
    for i=1:K
        figure(i+3), hist_fit(refl(mask==i),xi_est.mmse(i),scale_est.mmse(i),xi(i),scale(i));
    end
    
    colors = jet(256);
    figure(10), hold on
    for i=0:K-1
        plot(xi_est.sample(i+1,:),'Color',colors(round(i/(K)*255+1),:));
        hold on, plot(xi_est.mmse(i+1)*ones(steps,1),'r.');
        hold on, plot(xi(i+1)*ones(steps,1),'g.');
    end; hold off
    legend('samples','MMSE','truth');
    title('shape parameter')
    
    figure(11), hold on
    for i=0:K-1
        plot(scale_est.sample(i+1,:),'Color',colors(round(i/(K)*255+1),:));
        hold on, plot(scale_est.mmse(i+1)*ones(steps,1),'r.');
        hold on, plot(scale(i+1)*ones(steps,1),'g.');
    end; hold off
    legend('samples','MMSE','truth');
    title('scale parameter')
    
    figure(20)
    [n1,x1]=hist(sig2n_sample(1,n0+1:end),30);
    bar(x1,n1,'hist');
    ylim = get(gca,'ylim');
    hold on, line([sig2n_est.mmse(1) sig2n_est.mmse(1)], ylim, 'Color','r'); hold off
    hold on, line([sig2n_ref sig2n_ref], ylim, 'Color','g'); hold off
    title('histogram of \sigma_n^2')
    
    for k=1:K
        figure(20+k),
        [n1,x1]=hist(xi_sample(k,n0+1:end),30);
        bar(x1,n1,'hist');
        ylim=get(gca,'ylim');
        hold on, line([xi_est.mmse(k) xi_est.mmse(k)],ylim, 'Color','r'); hold off
        hold on, line([xi(k) xi(k)], ylim, 'Color','g'); hold off
        title(['Shape parameter - region ',num2str(k)])
    end
    
    for k=1:K
        figure(20+K+k),
        [n1,x1]=hist(scale_sample(k,n0+1:end),30);
        bar(x1,n1,'hist');
        ylim=get(gca,'ylim');
        hold on, line([scale_est.mmse(k) scale_est.mmse(k)],ylim, 'Color','r'); hold off
        hold on, line([scale(k) scale(k)], ylim, 'Color','g'); hold off
        title(['Scale parameter - region ',num2str(k)])
    end
    %% ground truth unknown
elseif refx==0
    figure(1),
    subplot(221),imagesc(y);colormap gray
    subplot(222),imagesc(x_hat);colormap gray
    subplot(223),imagesc(bmode_y);colormap gray
    subplot(224),imagesc(bmode_new);colormap gray
    
    figure(2),
    imagesc(psf_ref);
    
    figure(3),
    imagesc(z_map);colorbar
    
    figure(4),
    subplot(211),plot(epsilon)
    subplot(212),plot(accept_r)
    
    figure(5),plot(sig2n_est.sample),title('sig2n')
    hold on, plot(sig2n_est.mmse*ones(length(sig2n_est.sample),1),'r.'), hold off;
    legend('samples','MMSE');
    title('noise variance')
    
    for i=1:K
        figure(i+5), hist_fit(x_hat(z_map==i),xi_est.mmse(i),scale_est.mmse(i));
    end
    
    colors = jet(256);
    figure(10), hold on
    for i=0:K-1
        plot(xi_est.sample(i+1,:),'Color',colors(round(i/(K)*255+1),:));
        hold on, plot(xi_est.mmse(i+1)*ones(steps,1),'r.');
    end; hold off
    legend('samples','MMSE');
    title('shape parameter')
    
    figure(11), hold on
    for i=0:K-1
        plot(scale_est.sample(i+1,:),'Color',colors(round(i/(K)*255+1),:));
        hold on, plot(scale_est.mmse(i+1)*ones(steps,1),'r.');
    end; hold off
    legend('samples','MMSE');
    set(gca,'FontSize', 20)
    title('scale parameter')
    
    figure(20)
    [n1,x1]=hist(sig2n_sample(1,n0+1:end),30);
    bar(x1,n1,'hist');
    ylim = get(gca,'ylim');
    hold on, line([sig2n_est.mmse(1) sig2n_est.mmse(1)], ylim, 'Color','r'); hold off
    title('histogram of \sigma_n^2')
    
    for k=1:K
        figure(20+k),
        [n1,x1]=hist(xi_sample(k,n0+1:end),30);
        bar(x1,n1,'hist');
        ylim=get(gca,'ylim');
        hold on, line([xi_est.mmse(k) xi_est.mmse(k)],ylim, 'Color','r'); hold off
        title(['Shape parameter - region ',num2str(k)])
    end
    
    for k=1:K
        figure(20+K+k),
        [n1,x1]=hist(scale_sample(k,n0+1:end),30);
        bar(x1,n1,'hist');
        ylim=get(gca,'ylim');
        hold on, line([scale_est.mmse(k) scale_est.mmse(k)],ylim, 'Color','r'); hold off
        title(['Scale parameter - region ',num2str(k)])
    end
end


